<template>
  <div>
    <b-form-group label="Les marques" label-for="tags-with-dropdown">
      <b-form-tags
        id="tags-with-dropdown"
        v-model="value"
        no-outer-focus
        class="mb-2"
      >
        <template v-slot="{ tags, disabled, addTag, removeTag }">
          <ul v-if="tags.length > 0" class="list-inline d-inline-block mb-2">
            <li v-for="tag in tags" :key="tag" class="list-inline-item">
              <b-form-tag
                @remove="removeTag(tag)"
                :title="tag"
                :disabled="disabled"
                variant="warning "
                >{{ tag }}</b-form-tag
              >
            </li>
          </ul>

          <b-dropdown
            size="sm"
            variant="outline-secondary"
            block
            menu-class="w-100"
          >
            <template #button-content>
              <b-icon icon="tag-fill"></b-icon> Choisir une marque
            </template>
            <b-dropdown-form @submit.stop.prevent="() => {}">
              <b-form-group
                label="Chercher une marque"
                label-for="tag-search-input"
                label-cols-md="auto"
                class="mb-0"
                label-size="sm"
                :description="searchDesc"
                :disabled="disabled"
              >
                <b-form-input
                  v-model="search"
                  id="tag-search-input1"
                  type="search"
                  size="sm"
                  autocomplete="off"
                ></b-form-input>
              </b-form-group>
            </b-dropdown-form>
            <b-dropdown-divider></b-dropdown-divider>

            <b-overlay
              :show="loading"
              spinner-variant="warning"
              spinner-type="grow"
              spinner-small
              rounded="sm"
            >
              <b-dropdown-item-button
                v-for="option in availableOptions"
                :key="option"
                @click="onOptionClick({ option, addTag })"
              >
                {{ option }}
              </b-dropdown-item-button>
            </b-overlay>

            <b-dropdown-text v-if="availableOptions.length === 0">
              Il n'y a pas de filtres à choisir
            </b-dropdown-text>
          </b-dropdown>
        </template>
      </b-form-tags>
    </b-form-group>
  </div>
</template>

<script>
export default {
  data() {
    return {
      search: "",
      value: [],
    };
  },
  computed: {
    loading() {
      return this.$store.getters.loadingFiltersState;
    },
    allBrands() {
      return this.$store.getters.allBrands;
    },
    brandFilters: {
      get() {
        return this.$store.getters.filtersBrand;
      },
      set(newValue) {
        return newValue;
      },
    },
    criteria() {
      // Compute the search criteria
      return this.search.trim().toLowerCase();
    },
    availableOptions() {
      const criteria = this.criteria;
      // Filter out already selected options
      const options = this.allBrands.filter(
        (opt) => this.value.indexOf(opt) === -1
      );
      if (criteria) {
        // Show only options that match criteria
        return options.filter(
          (opt) => opt.toLowerCase().indexOf(criteria) > -1
        );
      }
      // Show all options available
      return options;
    },
    searchDesc() {
      if (this.criteria && this.availableOptions.length === 0) {
        return "Pas de resultats pour cette recherche";
      }
      return "";
    },
  },
  methods: {
    onOptionClick({ option, addTag }) {
      addTag(option);
      this.search = "";
      this.$store.dispatch("updateColorButton", "outline-warning");
    },
  },
  watch: {
    value(newVal) {
      this.$store.dispatch("updateBrandFilter", newVal);
      this.$store.dispatch("updateColorButton", "outline-warning");
      if (this.$store.getters.filtersBrand.length != 0) {
        this.$store.dispatch("updateOtherFilters");
      } else {
        // If there is no brand selected, update availableModels list to allModels
        this.$store.dispatch(
          "updateAvailableModels",
          this.$store.getters.allModels
        );
        this.$store.dispatch(
          "updateAvailableMotorizations",
          this.$store.getters.allMotorizations
        );
        this.$store.dispatch(
          "updateAvailableBodyWorks",
          this.$store.getters.allBodyWorks
        );
        this.$store.dispatch(
          "updateAvailableNumberOfPlaces",
          this.$store.getters.allNumberOfPlaces
        );
      }
    },
  },
  async beforeMount() {
    await this.$store.dispatch("fetchBrandResults");
  },
};
</script>